library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_arith.all;

entity operazioni is
port (din: in std_logic_vector(15 downto 0);
      nw,clk,rst: in std_logic;
      ris: out std_logic_vector(15 downto 0);
      fine: out std_logic
);
end operazioni;

architecture beh of operazioni is

type stato is (idle,decode,load,store);
signal cs: stato;
signal Acc0,Acc1: std_logic_vector (15 downto 0);
signal op: std_logic_vector (2 downto 0);
signal decode_en,load_en,store_en: std_logic;

begin

  process(clk,rst)
   begin
    if rst = '1' then
      cs <= idle;
    elsif clk'event and clk = '0' then 
      case cs is
        when idle => if nw = '1' then cs <= decode;
                     else cs <= idle;
                     end if;
        when decode => if op =  "000" or op= "100" then cs <= store;
                        elsif op= "001" then cs <= load;
                       else cs <= idle;
                       end if;
        when others => cs <= idle;
      end case;
    end if;
  end process;
   
   
   process(cs)
     begin
      case cs is
       when idle => decode_en <= '0';
                    load_en <= '0';
                    store_en <= '0';
       when decode => decode_en <= '1';
                      load_en <= '0';
                      store_en <= '0';                   
       when load => decode_en <= '0';
                    	 load_en <= '1';
                    	 store_en <= '0';
       when store => decode_en <= '0';
                    	 load_en <= '0';
                    	 store_en <= '1';           
     end case;
    end process;
     
     
     process(clk)
       begin
        if clk'event and clk = '0' then
           if nw = '1' then
              op <= din(2 downto 0);
           end if;
          
          if decode_en = '1' then
               case op is
                when "010" => Acc0 <= Acc0 + Acc1;
                	      fine<= '1';
                when "111" => Acc1 <= not Acc1;
                	      fine<= '1';
                when "011" => Acc0 <= conv_std_logic_vector(shl(signed(Acc0),unsigned(Acc1)),16);
                 	      fine<= '1';
                when others => fine<= '0';
               end case;
          end if;
          if  store_en = '1' then
               if op = "000" then Acc0 <= din;
               		     else Acc1 <= din;
               end if;
              fine<= '1';
          end if;
          
          if  load_en = '1' then
              ris <= Acc0;
              fine<= '1';
          end if;
          
          
                   
          if decode_en='0' and load_en='0' and store_en='0' then fine<= '0';
          end if;
     end if;      
   end process;
       
       
end beh;
       
       
       
       
       
       
       

