library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_arith.all;

entity operazioni is
port (din: in std_logic_vector(15 downto 0);
      nw,clk,rst: in std_logic;
      ris: out std_logic_vector(15 downto 0);
      fine: out std_logic
);
end operazioni;

architecture beh of operazioni is

type stato is (idle,decode,loadstore);
signal cs: stato;
signal Acc0,Acc1,tmp: std_logic_vector (15 downto 0);
signal op: std_logic_vector (2 downto 0);
signal decode_en,loadstore_en: std_logic;

begin

  process(clk,rst)
   begin
    if rst = '1' then
      cs <= idle;
    elsif clk'event and clk = '0' then 
      case cs is
        when idle => if nw = '1' then cs <= decode;
                     else cs <= idle;
                     end if;
        when decode => if op =  "000" or op= "100" or op= "001" then cs <= loadstore;
                       else cs <= idle;
                       end if;
        when others => cs <= idle;
      end case;
    end if;
  end process;
   
   
   process(cs)
     begin
      case cs is
       when idle => decode_en <= '0';
                    loadstore_en <= '0';
       when decode => decode_en <= '1';
                      loadstore_en <= '0';                   
       when loadstore => decode_en <= '0';
                    	 loadstore_en <= '1';
     end case;
    end process;
     
     
     process(clk)
       begin
        if clk'event and clk = '0' then
           if nw = '1' then
              op <= din(2 downto 0);
           end if;
          
          if decode_en = '1' then
               case op is
                when "010" => Acc0 <= Acc0 + Acc1;
                	      fine<= '1';
                when "111" => Acc1 <= Acc0;
                	      fine<= '1';
                when "011" => Acc0 <= Acc1 or Acc0;
                 	      fine<= '1';
                when others => fine<= '0';
               end case;
          end if;
          if  loadstore_en = '1' then
               case op is
                when "000" => Acc0 <= din;
                when "100" => Acc1 <= din;
                when "001" => ris <= Acc0;
                when others => null;
               end case;
              fine<= '1';
          end if;
          
          
                   
          if decode_en='0' and loadstore_en='0' then fine<= '0';
          end if;
     end if;      
   end process;
       
       
end beh;
       
       
       
       
       
       
       

