library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity operazioni is
port(
A,B: in std_logic_vector(15 downto 0);
nw,clk: in std_logic;
op: in std_logic_vector(2 downto 0);
dataout : out std_logic_vector(15 downto 0);
ready: out std_logic);

end operazioni;

architecture beh of operazioni is
type state is (idle,decodifica,leggi2, add,shift,andd,orr,prodotto);
signal st:state;
signal A0,B0,A1,B1,tmp: std_logic_vector(15 downto 0);
signal oper:  std_logic_vector(2 downto 0);
signal dec_en,add_en,shift_en,andd_en,orr_en,leggi2_en,prodotto_en: std_logic;
signal count: integer;
begin

process(clk)
begin
 if clk'event and clk='1' then
  case st is
   when idle=>
	if nw='1' then
		st<=decodifica;
	else st<= idle;
	end if;
   when decodifica=>
	case oper is
	 when "000" => 	st<=add;
	 when "001" =>	st<=shift;
	 when "010" =>	st<=andd;
	 when "011" =>	st<=orr;
	 when "100" => 	st<=leggi2;
	 when others => st <= idle;
	end case;	
   when leggi2=> st<=prodotto;
   when add=>  if count = 1 then st<=idle;
   		else st <= add;
   	       end if;
   when prodotto=> if count = 3 then st<=idle;
   		   else st <= prodotto;
   	           end if;
  when others=>  st<=idle;
 end case;
end if;
end process;


process(st)
begin

 case st is
  when decodifica=>
  
	dec_en<='1';
	add_en<='0';
	shift_en<='0';
	andd_en<='0';
	orr_en<='0';
	leggi2_en<='0';
	prodotto_en<='0';
	
  when add=>
   
	dec_en<='0';
	add_en<='1';
	shift_en<='0';
	andd_en<='0';
	orr_en<='0';
	leggi2_en<='0';
	prodotto_en<='0';
  when shift=>
	dec_en<='0';
	add_en<='0';
	shift_en<='1';
	andd_en<='0';
	orr_en<='0';
	leggi2_en<='0';
	prodotto_en<='0';
  when andd=>
	dec_en<='0';
	add_en<='0';
	shift_en<='0';
	andd_en<='0';
	orr_en<='0';
	leggi2_en<='0';
	prodotto_en<='0';
  when orr=>
	dec_en<='0';
	add_en<='0';
	shift_en<='0';
	andd_en<='0';
	orr_en<='1';
	leggi2_en<='0';
	prodotto_en<='0';
  when leggi2=>
	dec_en<='0';
	add_en<='0';
	shift_en<='0';
	andd_en<='0';
	orr_en<='0';
	leggi2_en<='1';
	prodotto_en<='0';
  when prodotto=>
	dec_en<='0';
	add_en<='0';
	shift_en<='0';
	andd_en<='0';
	orr_en<='0';
	leggi2_en<='0';
	prodotto_en<='1';
  when others=>
	dec_en<='0';
	add_en<='0';
	shift_en<='0';
	andd_en<='0';
	orr_en<='0';
	leggi2_en<='0';
	prodotto_en<='0';
 end case;
end process;

process(clk)
begin
 if clk'event and clk='1' then
  
  if nw='1' then
		A0<=A;
		B0<=B;
		oper<=op;
		count<= 0;
  end if;

  if leggi2_en='1' then
	A1<=A;
	B1<=B;
  end if;
  		
  if shift_en='1' then 
	dataout<=conv_std_logic_vector(shl(signed(A0),unsigned(B0)),16);
	ready <= '1';
  elsif andd_en='1' then
	dataout<=A0 and B0;
	ready <= '1';
  elsif orr_en='1' then
	dataout<=A0 or B0;
	ready <= '1';
  elsif add_en ='1' then
         if count < 1 then
             count <= count +1;
             ready <= '0';
         else  dataout<=A0+B0;
	       ready <= '1';
	 end if;
  elsif prodotto_en = '1' then
        if count < 3 then
             count <= count +1;
             ready <= '0';
         else  dataout <=(A0(7 downto 0)*B0(7 downto 0))+(A1(7 downto 0) * B1(7 downto 0));
    	       ready <= '1';
    	 end if;
   else ready <= '0';
  end if;
     	
        
  
  end if;

end process;



end beh;

