library ieee;

use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity esame is
port(
	v : in std_logic_vector(15 downto 0);
	i : in std_logic_vector(3 downto 0);
	nw, clk : in std_logic;
	op : in std_logic_vector(2 downto 0);
	dataout : out std_logic_vector(15 downto 0);
	ready : out std_logic
);
end esame;

architecture beh of esame is

type memo is array(0 to 15) of std_logic_vector(15 downto 0);
signal mem : memo;
type stati is (idle, decodifica, leggi2, loadstore, add);
signal cs : stati;
signal v0, v1 : std_logic_vector(15 downto 0);
signal ind : std_logic_vector(3 downto 0);
signal operation : std_logic_vector(2 downto 0);
signal dec_en, lettura2_en, loadstore_en, add_en, fine_en : std_logic;
signal conta,max : integer range 0 to 3;
signal appmem, appout : std_logic_vector(15 downto 0);

begin

process(clk)
begin
if clk'event and clk = '0' then
	case cs is
		when idle => if nw = '1' then
				cs <= decodifica;
				else cs <= idle;
				end if;
		when decodifica => case operation is
					when "000" | "100" => cs <= loadstore;
					when "001" | "011"=> cs <= leggi2;
					when "010" => cs <= add;
					when others => cs <= idle;
    				   end case;
    		when leggi2 => cs <= add;
    		when add => if conta = max then cs <= idle;
    				else cs <= add;
    				end if;
    		when others => cs <= idle;
	 end case;
end if;
end process;

process(cs)
 begin
   case cs is
	when idle =>  dec_en <= '0';
		      lettura2_en<= '0';
		      loadstore_en<= '0';
		      add_en<='0';
		      
	when decodifica => dec_en <= '1';
		      lettura2_en<= '0';
		      loadstore_en<= '0';
		      add_en<='0';
	
	when leggi2 => dec_en <= '0';
		      lettura2_en<= '1';
		      loadstore_en<= '0';
		      add_en<='0';
	when loadstore => dec_en <= '0';
		      lettura2_en<= '0';
		      loadstore_en<= '1';
		      add_en<='0';
	
	when add => dec_en <= '0';
		      lettura2_en<= '0';
		      loadstore_en<= '0';
		      add_en<='1';
	
   end case;
 end process;

process(clk)
begin
if clk'event and clk = '0' then
        
        if nw='1' then
           v0 <= v;
	   ind <= i;
	   operation <= op;
	   
	end if;
	
	if dec_en = '1' then
		conta <= 0;
		case operation is
		 when "001" => max <= 1;
		 when "010" => max<= 1;
		 when "011" => max <= 2;
		 when others => max <= 0;
		end case;
	end if;
	
	if lettura2_en = '1' then
		v1 <= v;
        end if;
        
	if loadstore_en = '1' then
	   if operation = "000" then
	          mem(conv_integer(ind)) <= v0;
	   else   dataout <= mem(conv_integer(ind));
	   end if;
	   ready <= '1';
	end if;
	
	if add_en = '1' then
	  if conta < max then
	   conta <= conta +1;
	  else case operation is 
	         when "001" => dataout <= v0+v1;
	         when "010" => dataout <= v0+mem(conv_integer(ind));
	         when "011" => mem(conv_integer(ind)) <= v0+v1;
	         when others => null;
	       end case;
	       ready <= '1';
	  end if;       
	
	end if;

    if loadstore_en= '0' and add_en='0' then ready <= '0';
    end if;
    
  end if;
end process;



end beh;

