library ieee;

use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity tbesame is
end tbesame;

architecture tbbesame of tbesame is
component esame is
port(
	v : in std_logic_vector(15 downto 0);
	i : in std_logic_vector(3 downto 0);
	nw, clk : in std_logic;
	op : in std_logic_vector(2 downto 0);
	dataout : out std_logic_vector(15 downto 0);
	ready : out std_logic
);
end component;

signal	v : std_logic_vector(15 downto 0);
signal	i : std_logic_vector(3 downto 0);
signal	nw, clk : std_logic;
signal	op : std_logic_vector(2 downto 0);
signal	dataout : std_logic_vector(15 downto 0);
signal	ready : std_logic;

begin

dut : esame port map(v,i,nw,clk,op,dataout,ready);

process
begin
clk <= '0';
wait for 5 ns;
clk <= '1';
wait for 5 ns;
end process;

nw <= '0' after 0 ns, '1' after 1 ns, '0' after 11 ns, '1' after 51 ns, '0' after 61 ns,
 '1' after 101 ns, '0' after 111 ns, '1' after 181 ns, '0' after 191 ns, '1' after 251 ns, '0' after 261 ns;
v <= conv_std_logic_vector(9,16) after 0 ns, conv_std_logic_vector(6,16) after 101 ns,
   conv_std_logic_vector(5,16) after 121 ns, conv_std_logic_vector(25,16) after 181 ns,
    conv_std_logic_vector(11,16) after 251 ns, conv_std_logic_vector(20,16) after 271 ns;
i <= conv_std_logic_vector(0,4) after 10 ns, conv_std_logic_vector(1,4) after 260 ns;
op<= conv_std_logic_vector(0,3) after 10 ns, "100" after 60 ns, "001" after 110 ns, "010" after 190 ns, "011" after 260 ns;

end tbbesame;

